var _excluded = ["inputRef", "loading", "invalid", "testId"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import { createStyledComponent, filterValidElementProps } from '@cloudflare/style-container';
var Input = /*#__PURE__*/React.forwardRef((_ref, ref) => {
  var {
    inputRef,
    loading,
    invalid,
    testId
  } = _ref,
      restProps = _objectWithoutProperties(_ref, _excluded);

  var props = filterValidElementProps('input', restProps);
  return /*#__PURE__*/React.createElement("input", _extends({
    "data-testid": testId
  }, props, {
    ref: ref !== null && ref !== void 0 ? ref : inputRef
  }));
});
Input.propTypes = {
  type: PropTypes.oneOf(['text', 'email', 'number', 'password', 'search', 'color', 'url', 'checkbox', 'tel', 'time']),
  name: PropTypes.string.isRequired,
  value: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  defaultValue: PropTypes.string,
  onChange: PropTypes.func.isRequired,
  onPaste: PropTypes.func,
  onKeyDown: PropTypes.func,
  inputRef: PropTypes.oneOfType([PropTypes.object, PropTypes.func]),
  onBlur: PropTypes.func,
  onFocus: PropTypes.func,
  placeholder: PropTypes.string,
  autoComplete: PropTypes.string,
  autoFocus: PropTypes.bool,
  className: PropTypes.string,
  disabled: PropTypes.bool,
  loading: PropTypes.bool,
  invalid: PropTypes.bool,
  testId: PropTypes.string,
  spellCheck: PropTypes.bool,
  maxLength: PropTypes.number,
  min: PropTypes.number,
  max: PropTypes.number,
  required: PropTypes.bool,
  compact: PropTypes.bool
};
Input.defaultProps = {
  type: 'text'
};
Input.displayName = 'Input';
export default createStyledComponent(_ref2 => {
  var {
    theme,
    loading,
    invalid,
    disabled,
    compact
  } = _ref2;
  return _objectSpread(_objectSpread({
    marginBottom: 3,
    px: compact ? "".concat(theme.space[1] * 1.5, "px") : theme.space[2],
    py: compact ? "".concat(theme.space[1], "px") : "".concat(theme.space[2], "px"),
    height: 'initial',
    lineHeight: 'initial',
    flex: 'initial',
    zIndex: 0,
    width: '100%',
    verticalAlign: 'middle',
    textIndent: 'initial'
  }, theme.mixins.input({
    invalid,
    disabled: disabled || loading,
    compact
  })), theme.mixins.focus({
    invalid,
    border: true
  }));
}, Input);