"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styleContainer = require("@cloudflare/style-container");

var _excluded = ["inputRef", "loading", "invalid", "testId"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Input = /*#__PURE__*/_react.default.forwardRef(function (_ref, ref) {
  var inputRef = _ref.inputRef,
      loading = _ref.loading,
      invalid = _ref.invalid,
      testId = _ref.testId,
      restProps = _objectWithoutProperties(_ref, _excluded);

  var props = (0, _styleContainer.filterValidElementProps)('input', restProps);
  return /*#__PURE__*/_react.default.createElement("input", _extends({
    "data-testid": testId
  }, props, {
    ref: ref !== null && ref !== void 0 ? ref : inputRef
  }));
});

Input.propTypes = {
  type: _propTypes.default.oneOf(['text', 'email', 'number', 'password', 'search', 'color', 'url', 'checkbox', 'tel', 'time']),
  name: _propTypes.default.string.isRequired,
  value: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  defaultValue: _propTypes.default.string,
  onChange: _propTypes.default.func.isRequired,
  onPaste: _propTypes.default.func,
  onKeyDown: _propTypes.default.func,
  inputRef: _propTypes.default.oneOfType([_propTypes.default.object, _propTypes.default.func]),
  onBlur: _propTypes.default.func,
  onFocus: _propTypes.default.func,
  placeholder: _propTypes.default.string,
  autoComplete: _propTypes.default.string,
  autoFocus: _propTypes.default.bool,
  className: _propTypes.default.string,
  disabled: _propTypes.default.bool,
  loading: _propTypes.default.bool,
  invalid: _propTypes.default.bool,
  testId: _propTypes.default.string,
  spellCheck: _propTypes.default.bool,
  maxLength: _propTypes.default.number,
  min: _propTypes.default.number,
  max: _propTypes.default.number,
  required: _propTypes.default.bool,
  compact: _propTypes.default.bool
};
Input.defaultProps = {
  type: 'text'
};
Input.displayName = 'Input';

var _default = (0, _styleContainer.createStyledComponent)(function (_ref2) {
  var theme = _ref2.theme,
      loading = _ref2.loading,
      invalid = _ref2.invalid,
      disabled = _ref2.disabled,
      compact = _ref2.compact;
  return _objectSpread(_objectSpread({
    marginBottom: 3,
    px: compact ? "".concat(theme.space[1] * 1.5, "px") : theme.space[2],
    py: compact ? "".concat(theme.space[1], "px") : "".concat(theme.space[2], "px"),
    height: 'initial',
    lineHeight: 'initial',
    flex: 'initial',
    zIndex: 0,
    width: '100%',
    verticalAlign: 'middle',
    textIndent: 'initial'
  }, theme.mixins.input({
    invalid: invalid,
    disabled: disabled || loading,
    compact: compact
  })), theme.mixins.focus({
    invalid: invalid,
    border: true
  }));
}, Input);

exports.default = _default;