"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styleContainer = require("@cloudflare/style-container");

var _componentBox = require("@cloudflare/component-box");

var _Input = _interopRequireDefault(require("./Input"));

var _excluded = ["label", "disabled", "position"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var InputLabel = (0, _styleContainer.createStyledComponent)(function (_ref) {
  var theme = _ref.theme,
      disabled = _ref.disabled;
  return {
    color: 'gray.3',
    textAlign: 'center',
    backgroundColor: 'gray.9',
    borderColor: 'gray.5',
    borderTop: "1px solid ".concat(theme.colors.gray[5]),
    borderBottom: "1px solid ".concat(theme.colors.gray[5]),
    whiteSpace: 'nowrap',
    p: 2,
    fontSize: 2,
    lineHeight: 'initial',
    opacity: disabled ? 0.5 : 1,
    fontFamily: theme.fontFamily
  };
});
var LeftPositionedLabel = (0, _styleContainer.createStyledComponent)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    borderLeft: "1px solid ".concat(theme.colors.gray[5]),
    borderTopLeftRadius: '1px',
    borderBottomLeftRadius: '1px',
    marginRight: '-1px'
  };
}, InputLabel);
var RightPositionedLabel = (0, _styleContainer.createStyledComponent)(function (_ref3) {
  var theme = _ref3.theme;
  return {
    borderRight: "1px solid ".concat(theme.colors.gray[5]),
    borderTopRightRadius: '1px',
    borderBottomRightRadius: '1px'
  };
}, InputLabel);

var LabeledInput = function LabeledInput(_ref4) {
  var label = _ref4.label,
      disabled = _ref4.disabled,
      _ref4$position = _ref4.position,
      position = _ref4$position === void 0 ? 'left' : _ref4$position,
      otherProps = _objectWithoutProperties(_ref4, _excluded);

  return /*#__PURE__*/_react.default.createElement(_componentBox.Box, {
    display: "flex",
    width: "100%",
    mb: 3
  }, position === 'left' && label && /*#__PURE__*/_react.default.createElement(LeftPositionedLabel, {
    disabled: disabled
  }, label), /*#__PURE__*/_react.default.createElement(_componentBox.Box, {
    flexGrow: 1
  }, /*#__PURE__*/_react.default.createElement(_Input.default, _extends({
    disabled: disabled
  }, otherProps, {
    mb: 0,
    borderRadius: "0 1px 1px 0"
  }))), position === 'right' && label && /*#__PURE__*/_react.default.createElement(RightPositionedLabel, {
    disabled: disabled
  }, label));
};

LabeledInput.displayName = 'LabeledInput';
LabeledInput.propTypes = {
  label: _propTypes.default.string,
  disabled: _propTypes.default.bool
};
var _default = LabeledInput;
exports.default = _default;